#include "memory.h"
#include "letters.h"

void write_word(int address, int word) {
    int *a = (int*) address;
    *a = word;
}

int read_word(int address) {
    int *a = (int*) address;
    return *a;
}

u8 read_byte(int address) {
    u8 *a = (u8*) address;
    return *a;
}

void write_byte(int address, char byte) {
    char *a = (char*) address;
    *a = byte;
}

void* find_byte_sequence(char* sequence, int num, int base_address) {
    char* c = (char*) base_address;
    while (1) {
        if (*c == sequence[0]) {
            int i;
            for (i = 1; i < num; i++) {
                if (*(c + i) == sequence[i]) {

                } else {
                    break;
                }
                return (void*) c;
            }
        }
        c++;
    }
}

void paintPixel3D(int x, int y, char r, char g, char b, int offset3D) {


    char *c;
    offset3D *= 720;
    int coord = (720 * x + 720 - (3 * y + 3));

    c = (char*) (coord + TOP_LEFT_FRAME1 - offset3D);
    * c = b;
    *(c + 1) = g;
    *(c + 2) = r;
    c = (char*) (coord + TOP_LEFT_FRAME2 - offset3D);
    * c = b;
    *(c + 1) = g;
    *(c + 2) = r;

    //if(offset3D==0)return; bad idea

    c = (char*) (coord + TOP_RIGHT_FRAME1 + offset3D);
    * c = b;
    *(c + 1) = g;
    *(c + 2) = r;

    c = (char*) (coord + TOP_RIGHT_FRAME2 + offset3D);
    * c = b;
    *(c + 1) = g;
    *(c + 2) = r;

    //write_color(coord + screen, r, g, b);
}

void paintPixel2D(int x, int y, char r, char g, char b) {


    char *c;
    int coord = (720 * x + 720 - (3 * y + 3));

    c = (char*) (coord + SUB_FRAME1);
    * c = b;
    *(c + 1) = g;
    *(c + 2) = r;
    c = (char*) (coord + SUB_FRAME2);
    * c = b;
    *(c + 1) = g;
    *(c + 2) = r;

    //write_color(coord + screen, r, g, b);
}

void paint_line(int x, int y, int length, int dir, int color, int screen) {


    char *coord = (char*) (720 * x + 720 - (3 * y + 3) + screen);
    int i;
    if (dir == 0) {
        for (i = 0; i < length; i++) {
            *(coord++) ^= color;
            *(coord++) ^= color;
            *(coord++) ^= color;
            coord += 717;
        }

    } else {
        for (i = 0; i < length; i++) {
            *(coord++) ^= color;
            *(coord++) ^= color;
            *(coord++) ^= color;
            // coord+=719;
        }

    }




    //write_color(coord + screen, r, g, b);
}

void paintLetter2D(char letter, int x, int y, char r, char g, char b) {

    int i = 0;
    int k = 0;
    int c = 0;
    char mask = 0;
    //unsigned char* _letter;
    char l = 0;
    c = letter * 8;

    for (i = 0; i < 8; i++) {
        mask = 0b10000000;
        l = font[i + c];
        for (k = 0; k < 8; k++) {
            if ((mask >> k) & l) {
                paintPixel2D(k + x, i + y, r, g, b);
            }
        }
    }
}

void paintLetter3D(char letter, int x, int y, char r, char g, char b) {

    int i = 0;
    int k = 0;
    int c = 0;
    char mask = 0;
    //unsigned char* _letter;
    char l = 0;
    c = letter * 8;

    for (i = 0; i < 8; i++) {
        mask = 0b10000000;
        l = font[i + c];
        for (k = 0; k < 8; k++) {
            if ((mask >> k) & l) {
                paintPixel3D(k + x, i + y, r, g, b, 0);
            }
        }
    }
}

int strlen(char* string) {
    int i;
    for (i = 0;; i++) {
        if (string[i] == 0x00) {
            return i;
        }
    }
}

void paint_word(char* word, int x, int y, char r, char g, char b, int screen) {
    int tmp_x = x;
    int i;
    int line = 0;

    for (i = 0; i < strlen(word); i++) {

        if (tmp_x + 8 > TOP_WIDTH) {
            line++;
            tmp_x = x;
        }
        paintLetter2D(word[i], tmp_x, y + (line * 8), r, g, b);

        tmp_x = tmp_x + 8;
    }

}

void paint3Dword(char* word, int x, int y, char r, char g, char b, int offset3D) {
    int tmp_x = x; //offset3D is the pixel distance of the right frame from x,
    //and the pixel distance of the left frame from x in the other direction
    int i; //[left frame]  <---offset--->  [x,y]  <---offset--->  [right frame]
    int line = 0;

    //offset3D%=0x21; //offset limited to 32,-32

    for (i = 0; i < strlen(word); i++) {

        if (tmp_x + 8 > TOP_WIDTH) {
            line++;
            tmp_x = x;
        }
        paintLetter3D(word[i], tmp_x + offset3D, y + (line * 8), r, g, b);
        paintLetter3D(word[i], tmp_x - offset3D, y + (line * 8), r, g, b);


        tmp_x = tmp_x + 8;
    }

}

void hexDump(int start, int length, int x, int y) {
    unsigned char* Gcv = (unsigned char*) start;
    unsigned char check = 0;
    int z = x, W = 255;
    unsigned char nib = 0;

    for (z = 0; z < length; z++) {
        if (z & 1)W = 255;
        else W = 128;
        check = *Gcv;

        nib = (check & 255) >> 4;
        if (nib < 10) {
            paintLetter2D(nib + 48, z * 16, y, 0, W, 0);
        } else {
            nib -= 10;
            paintLetter2D(nib + 65, z * 16, y, 0, W, 0);
        }
        nib = (check & 255) & 15;
        if (nib < 10) {
            paintLetter2D(nib + 48, z * 16 + 8, y, 0, W, 0);
        } else {
            nib -= 10;
            paintLetter2D(nib + 65, z * 16 + 8, y, 0, W, 0);
        }
        Gcv++;
        check = 0;
        nib = 0;
    }

}

void printInteger(s64 num, int x, int y, char r, char g, char b) {
    char s;
    char t;

    if (num < 0) {
        t = '-';
        num *= -1;
    } else
        t = ' ';

    int count = 0;

    while (count < r) {
        s = (char) (num & 15);

        if (s < 10)s = s + 48;
        else
            s = s + 55;

        if (count > 5)g = 255;
        else
            g = 128;

        paintLetter2D(s, x -= 8, y, g, g, g);

        count++;
        num = num >> 4;

    }

    paintLetter2D('x', x -= 8, y, g, g, g);
    paintLetter2D('0', x -= 8, y, g, g, g);
    paintLetter2D(t, x -= 8, y, g, g, g);
}

void wait(int t) {
    int i = 0;
    int j = 0;
    int z = 0;

    for (i = 0; i < t; i++) {
        for (j = 0; j < t; j++) {
            z = 10 / 33;
        }
    }

};

void clear(int size, int col, int offset) {
    int *p = (int*) offset;

    size >> 2;

    while (size--) {
        *p = 0;
        p++;
    }

};

void drawBox(int x, int y, int w, int h, int color, int offset3D, int address) {
    x += offset3D;
    int coord = 720 * x + 720 - (3 * y + 3);
    int* p = (int*) (address + coord);
    int* t;
    h = (h * 3) >> 2;
    for (x = 0; x < w; x++) {
        t = p;
        for (y = 0; y < h; y++) {
            *p = color;
            p++;
        }
        p = t + 180;
    }

};

