#ifndef MEMORY_H
#define MEMORY_H

#define STACK_SIZE 0x00004000
#define FCRAM_BASE 0x20000000
#define TOP_ASPECT_X 0x5
#define TOP_ASPECT_Y 0x3
#define TOP_HEIGHT 240
#define TOP_WIDTH 400
#define BOTTOM_WIDTH 320
#define FRAMEBUFFER_SEL 0x20184E59
#define TOP_LEFT_FRAME1 0x20184E60
#define TOP_LEFT_FRAME2 0x201CB370
#define TOP_RIGHT_FRAME1 0x20282160
#define TOP_RIGHT_FRAME2 0x202C8670
#define SUB_FRAME1 0x202118E0
#define SUB_FRAME2 0x20249CF0 //539039968

// IO
#define STATE_3D_SLIDER 0x1FF81080
#define TIMER 0x10003000
#define HID 0x10146000 

typedef char s8;
typedef unsigned char u8;
typedef short s16;
typedef unsigned short u16;
typedef int s32;
typedef unsigned int u32;
typedef long long int s64; //necessary for acceptible precision in fixed point
typedef unsigned long long int u64;

u8 read_byte(int address);
void write_byte(int address, char byte);
int read_word(int address);
void write_word(int address, int word);
void write_color(int address, char r, char g, char b);
int read_word(int address);
void* find_byte_sequence(char* sequence, int num, int base_address);
void paintPixel3D(int x, int y, char r, char g, char b,int offset3D); //top screen
void paintPixel2D(int x, int y, char r, char g, char b); //bottom screen
void paint_line(int x, int y, int length, int dir, int color, int screen);
void paint_line(int x, int y, int length, int dir, int color, int screen);
void paintLetter2D(char letter, int x, int y, char r, char g, char b);
void paintLetter3D(char letter, int x, int y, char r, char g, char b);
void paint_word(char* word, int x,int y, char r, char g, char b, int screen);
void paint3Dword(char* word, int x,int y, char r, char g, char b,int offset3D);
void hexDump(int start, int length, int x,int y);
int strlen(char* string);
void printInteger(s64 num, int x, int y, char r, char g, char b);
void wait(int t);
void clear(int size, int col, int offset);
void drawBox(int x, int y, int w, int h, int color,int offset3D, int address);
//void itoa(s64 n, char s[]);
//void reverse(char s[]);
#endif

